package ch.epfl.ppo;

/**
 * Une image continue et infinie, représentée par une fonction associant une
 * couleur à chaque point du plan.
 */
public interface ImageRGB {
    public ColorRGB valueAt(double x, double y);

    public static final ImageRGB RED_CIRCLE = (x, y) -> {
        double r = Math.sqrt(x * x + y * y);
        return r <= 1.0 ? ColorRGB.RED : ColorRGB.WHITE;
    };

    public default ImageRGB flattened() {
        return (x, y) -> valueAt(x, y * 2d);
    }
}
